<?php

namespace App\Http\Controllers;
use App\Models\modelStatements;
use Illuminate\Http\Request;
use App\Models\modelTenants;

use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Support\Facades\Session;
class StatementsController extends Controller
{
    public function index($Type)
    {
      

            try
            {
                $currencys=modelStatements::selectcurrency(Session::get('PropertyCode'));

                $Accounts=modelStatements::selectTenants(Session::get('PropertyCode'));
                if($Type=="Tenant")
            {
                $Accounts=modelStatements::selectTenants(Session::get('PropertyCode'));
                $floors = modelTenants::selectFloors(Session::get('PropertyCode'));

            }
            else   if($Type=="Customer")
            {
              
                $Accounts=modelStatements::selectCustomer(Session::get('PropertyCode'));
                
            }
            else  if($Type=="Supplier")
            {
                $Accounts=modelStatements::selectSupplier(Session::get('PropertyCode'));

            }
            $name=  $Type;
            $code=  "0000";
            $openingBalance=0;
            $from="";
            $to="";
            $currnames="";

                $trans=modelStatements::selectTrans1(Session::get('PropertyCode'));
                $cst=modelStatements::selectInvoiceCustomer(Session::get('PropertyCode'),$Type,"");
                $pdetails=modelStatements::selectInvoiceProperty(Session::get('PropertyCode'),Session::get('RegNo'));
    
    

                return view('/Statements', compact('Accounts','Type','trans','name','code','currencys','from','to','currnames','openingBalance','cst','pdetails', 'floors'));
               


        } catch (\Exception $e) {
            
            return redirect()->route('otheraccounts')->withErrors(['error' => 'An error occurred!!' . $e->getMessage()]);
        }

        }


        public function fetchAllTransactions(Request $request)
        {
            $request->validate([
                'from' => 'required|string',
                'to' => 'required|string',
                'curr' => 'required|string',
                'Type' => 'required|string', // Must always be "Tenant" for this function
            ]);
        
            $from = $request->input('from');
            $to = $request->input('to');
            $curr = $request->input('curr');
            $Type = $request->input('Type');
            $contraCode = $request->input('statement_type', 'both'); // Default to 'both' if not provided
        
            if ($Type !== 'Tenant') {
                return redirect()->route('statements')->withErrors(['error' => 'This function only supports tenant transactions']);
            }
        
            // Fetch currency details
            $currname = modelStatements::selectcurrencyName(Session::get('PropertyCode'), $curr);
            $currnames = $currname[0]->Name;
        
            // Fetch all tenants for the property
            $Accounts = modelStatements::selectTenants(Session::get('PropertyCode'));
            $allTransactions = []; // Store all tenant transactions
        
            foreach ($Accounts as $tenant) {
                $AccCode = $tenant->AccCode;
                $AccSubCode = $tenant->AccSubCode;
        
                // Fetch tenant-specific transactions
                $transactions = modelStatements::selectHomeTrans2(
                    Session::get('PropertyCode'),
                    $AccCode,
                    $AccSubCode,
                    $curr,
                    $from,
                    $to,
                    $Type,
                    $contraCode
                );
        
                // Fetch additional customer-specific information
                $customerInfo = modelStatements::selectInvoiceCustomer(Session::get('PropertyCode'), $Type, $AccSubCode);
        
                // Store transactions indexed by tenant account subcode
                $allTransactions[$tenant->AccSubCode] = [
                    'name' => $tenant->AccName,
                    'transactions' => $transactions,
                    'customerInfo' => $customerInfo,
                ];
            }
        
            // Fetch property details
            $propertyDetails = modelStatements::selectInvoiceProperty(Session::get('PropertyCode'), Session::get('RegNo'));
        
            return view('/allTenantsStatements', compact(
                'Accounts',
                'allTransactions',
                'currnames',
                'from',
                'to',
                'propertyDetails'
            ));
        }
        

        public function fetchTransactions(Request $request)
        {
            $request->validate([
                'Type' => 'required|string',
                'from' => 'required|string',
                'to' => 'required|string',
                'curr' => 'required|string',
                'statement_type' => 'string',
            ]);
        
            $Rate = 1;
            $accounts = $request->input('account');
            $from = $request->input('from');
            $to = $request->input('to');
            $curr = $request->input('curr');
            $Type = $request->input('Type');
            $from_floor = $request->input("floor_from");
            $to_floor = $request->input("floor_to");
            $contraCode = $request->input('statement_type');
        
            $currname = modelStatements::selectcurrencyName(Session::get('PropertyCode'), $curr);
            $currnames = $currname[0]->Name;
        
            $Accounts = [];
            $allTransactions = []; // To store transactions for all tenants
            $trans = []; // Transactions for a single tenant (will remain empty if $accounts == "all")
            if ($accounts == "all") {
                // Fetch all tenants
                $Accounts = modelStatements::selectTenantsByFloor(Session::get('PropertyCode'), $from_floor, $to_floor);
        
                // Loop through each tenant and fetch their transactions
                foreach ($Accounts as $tenant) {
                    $AccCode = $tenant->AccCode;
                    $AccSubCode = $tenant->AccSubCode;
        
                    // Fetch transactions using selectHomeTrans2
                    if ($contraCode == "both") {
                        $transactions = modelStatements::selectHomeTrans(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type);
                        $transOpening = modelStatements::selectHomeTransOpening(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type);


                    } else {
                   
                    $transactions = modelStatements::selectHomeTrans2(
                        Session::get('PropertyCode'),
                        $AccCode,
                        $AccSubCode,
                        $curr,
                        $from,
                        $to,
                        $Type,
                        $contraCode
                    );
                    $transOpening = modelStatements::selectHomeTransOpening2(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type, $contraCode);

                }
        
                    // Store transactions indexed by tenant
                    $allTransactions[$tenant->AccSubCode] = [
                        'name' => $tenant->AccName,
                        'transactions' => $transactions,
                        "openingBalance"=>$transOpening,
                    ];
                    
                }
                $currencys = modelStatements::selectcurrency(Session::get('PropertyCode'));
                $openingBalance = 0;
            } else {
                // Handle single tenant logic
                $accounts = explode(':', $accounts);
                $AccCode = $accounts[0];
                $AccSubCode = isset($accounts[1]) ? $accounts[1] : '0';
        
                if ($Type == "Tenant") {
                    $Accounts = modelStatements::selectTenants1(Session::get('PropertyCode'), $AccSubCode);
                    $floors = modelTenants::selectFloors(Session::get('PropertyCode'));
                } elseif ($Type == "Customer") {
                    $Accounts = modelStatements::selectCustomer1(Session::get('PropertyCode'), $AccSubCode);
                } elseif ($Type == "Supplier") {
                    $Accounts = modelStatements::selectSupplier1(Session::get('PropertyCode'), $AccSubCode);
                }
        
                $name = $Accounts[0]->AccName;
                $code = $Accounts[0]->AccSubCode;
                $currencys = modelStatements::selectcurrency(Session::get('PropertyCode'));
                $openingBalance = 0;
        
                $trans = modelStatements::selectTrans(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type);
                $transOpening = $trans;
        
                $selectHomeCurrency = modelStatements::selectHomeCurrency(Session::get('PropertyCode'));
        
                if (count($selectHomeCurrency) > 0) {
                    $homeCurrency = $selectHomeCurrency[0]->Currency;
                    if ($curr == $homeCurrency) {
                        if ($contraCode == "both") {
                            $trans = modelStatements::selectHomeTrans(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type);
                            $transOpening = modelStatements::selectHomeTransOpening(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type);

                        } else {
                            $trans = modelStatements::selectHomeTrans2(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type, $contraCode);
                            $transOpening = modelStatements::selectHomeTransOpening2(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type, $contraCode);
                        }
                        $openingBalance = $transOpening[0]->total;
                    } else {
                        $myRateValidation = modelStatements::selectRate(Session::get('PropertyCode'), $curr, $AccCode, $AccSubCode, $from, $to);
        
                        if (count($myRateValidation) == 0) {
                            return redirect()->route('statements', ['Type' => $Type])->withErrors(['error' => 'Cannot Run This Report With The Selected Currency']);
                        } else {
                            $trans = modelStatements::selectTrans(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type);
                            $transOpening = modelStatements::selectTransOpeningBalance(Session::get('PropertyCode'), $AccCode, $AccSubCode, $curr, $from, $to, $Type);
                            $openingBalance = $transOpening[0]->total;
                        }
                    }
                } else {
                    return redirect()->route('statements', ['Type' => $Type])->withErrors(['error' => 'Home Currency Not Found']);
                }
            }
            $floors = modelTenants::selectFloors(Session::get('PropertyCode'));

            $pdetails=modelStatements::selectInvoiceProperty(Session::get('PropertyCode'),Session::get('RegNo'));
            $cst=modelStatements::selectInvoiceCustomer(Session::get('PropertyCode'),$Type,$AccSubCode);
            if(!empty($trans)){
                return view('/Statements', compact('Accounts', 'Type', 'trans', 'allTransactions', 'name', 'code', 'currencys', 'from', 'to', 'currnames', 'openingBalance', 'floors', 'pdetails', 'cst'));

            }
            else{
                return view('/Statements', compact('Accounts', 'Type', 'trans', 'allTransactions', 'currencys', 'from', 'to', 'currnames', 'openingBalance', 'floors', 'pdetails', 'cst'));

            }
        }
        


        public function indexGeneralLedger()
        {
          
    
                try
                {
                    $currencys=modelStatements::selectcurrency(Session::get('PropertyCode'));
    
                    $Accounts=modelStatements::selectgl(Session::get('PropertyCode'));
          
                $name=  "";
                $code=  "0000";
                $openingBalance=0;
                $from="";
                $to="";
                $currnames="";
    
                    $trans=modelStatements::selectTrans1(Session::get('PropertyCode'));
    
                    return view('/GLReport', compact('Accounts','trans','name','code','currencys','from','to','currnames','openingBalance'));
                   
    
    
            } catch (\Exception $e) {
                
                return redirect()->route('otheraccounts')->withErrors(['error' => 'An error occurred!!' . $e->getMessage()]);
            }
    
            }

            public function fetchGeneralLedger(Request $request)
            {
    
                $request->validate([
                    
                     'from' => 'required|string',
                      'to' => 'required|string',
                      'curr' => 'required|string'
                    
                ]);
    
             
    
                $Rate=1;
                $accounts = $request->input('account');
                $from = $request->input('from');
                $to = $request->input('to');
                $curr = $request->input('curr');
                $accounts = explode(':', $accounts);
                $AccCode = $accounts[0];
                $AccSubCode = isset($accounts[1]) ? $accounts[1] : '0'; 
                $Type = "GL";
    
               
    
                $currname=modelStatements::selectcurrencyName(Session::get('PropertyCode'),$curr);
                $currnames=$currname[0]->Name;
    
                if($AccSubCode=="0")
                {
                    $Accounts=modelStatements::selectglByCode(Session::get('PropertyCode'),$AccCode);
                    $name=  $Accounts[0]->AccName;
                    $code=  $Accounts[0]->AccCode;

                }
                else
                {

                   
                    $Accounts=modelStatements::selectglByCode1(Session::get('PropertyCode'),$AccCode,$AccSubCode );
                    $name=  $Accounts[0]->AccName;
                    $code=  $Accounts[0]->AccCode;
                }
                $Accounts=modelStatements::selectgl(Session::get('PropertyCode'));
               
                $currencys=modelStatements::selectcurrency(Session::get('PropertyCode'));
                $openingBalance=0;
    
                $trans=modelStatements::selectTrans(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to, $Type);
                $transOpening=$trans;
    
                $selectHomeCurrency=modelStatements::selectHomeCurrency(Session::get('PropertyCode'));
    
                if(count($selectHomeCurrency)>0)
                {
                    $homeCurrency=$selectHomeCurrency[0]->Currency; 
                    if($curr==$homeCurrency)
                    {
    
                
                        $trans=modelStatements::selectHomeTrans(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to, $Type);
     
    
                        
                    }
                    else
                    {
                        $myRateValidation=modelStatements::selectRate(Session::get('PropertyCode'),$curr,$AccCode,$AccSubCode, $from, $to);
    
                        if(count($myRateValidation)==0)
                        {
                            return redirect()->route('statements',['Type'=>$Type])->withErrors(['error' => 'Cannot Run This Report With The Selected Currency' ]);
                        }
                        else
                        {
    
                        $trans=modelStatements::selectTrans(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to, $Type);
                       
                    
                    }
    
                    }
    
                }
                else
                {
                    return redirect()->route('GLReport',['Type'=>$Type])->withErrors(['error' => 'Home Currency Not Found' ]);
            
                }
    
    
    
    
               
                return view('/GLReport', compact('Accounts','trans','name','code','currencys','from','to','currnames','openingBalance'));
    
            }

        public function PrintChartOfAccounts()
    {
      

            try
            {
            
                $Accs=modelStatements::selectgl(Session::get('PropertyCode'));
                $Accounts=modelStatements::selectAccountsTypes(Session::get('PropertyCode'));
                $type="All";

                return view('/ChartOfAccountsReport', compact('Accounts','Accs','type'));
               


        } catch (\Exception $e) {
            
            return redirect()->route('otheraccounts')->withErrors(['error' => 'An error occurred!!' . $e->getMessage()]);
        }

        }

        public function fetchAccountsByType(Request $request)
        {

            $request->validate([
                'account' => 'required|string'
                
            ]);

            $accounts = $request->input('account');

            if($accounts=="All")
            {

                $Accs=modelStatements::selectgl(Session::get('PropertyCode'));
                $Accounts=modelStatements::selectAccountsTypes(Session::get('PropertyCode'));
                $type="All";

                return view('/ChartOfAccountsReport', compact('Accounts','Accs','type'));



            }
            else
            {


                $Accs=modelStatements::selectglByType(Session::get('PropertyCode'),$accounts);
                $Accounts=modelStatements::selectAccountsTypes(Session::get('PropertyCode'));
                $types=modelStatements::selectAccountsTypesBYID(Session::get('PropertyCode'),$accounts);
                $type=$types[0]->Name;

                return view('/ChartOfAccountsReport', compact('Accounts','Accs','type'));


            }



        }


        public function indexCashBook()
        {
          
    
                try
                {
                    $currencys=modelStatements::selectcurrency(Session::get('PropertyCode'));
    
                    $Accounts=modelStatements::selectglCashBook(Session::get('PropertyCode'));
               
              
                $code=  "0000";
                $from="";
                $to="";
                $currnames="";
                $name="CashBook";
                $openingBalance=0;
    
                    $trans=modelStatements::selectTrans1(Session::get('PropertyCode'));
    
                    return view('/CashBookReport', compact('Accounts','trans','code','currencys','from','to','currnames','name','openingBalance'));
                   
    
    
            } catch (\Exception $e) {
                
                return redirect()->route('otheraccounts')->withErrors(['error' => 'An error occurred!!' . $e->getMessage()]);
            }
    
            }


        public function fetchCashBookReport(Request $request)
        {

            $request->validate([
                'account' => 'required|string',
                 'from' => 'required|string',
                  'to' => 'required|string',
                  'curr' => 'required|string'
                
            ]);

         

            $Rate=1;
            $accounts = $request->input('account');
            $from = $request->input('from');
            $to = $request->input('to');
            $curr = $request->input('curr');
            $AccSubCode="0";
            $AccCode = $accounts;
            

           

            $currname=modelStatements::selectcurrencyName(Session::get('PropertyCode'),$curr);
            $currnames=$currname[0]->Name;

            $Accounts=modelStatements::selectglCashBookBYCode(Session::get('PropertyCode'),$accounts);
            $name=  $Accounts[0]->Name;
            $code=  $Accounts[0]->AccCode;
            $openingBalance=0;
            $currencys=modelStatements::selectcurrency(Session::get('PropertyCode'));
            $trans=modelStatements::selectTrans(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to,"CashBook");
            $transOpening=$trans;
            $selectHomeCurrency=modelStatements::selectHomeCurrency(Session::get('PropertyCode'));

            if(count($selectHomeCurrency)>0)
            {
                $homeCurrency=$selectHomeCurrency[0]->Currency; 
                if($curr==$homeCurrency)
                {
                    $trans=modelStatements::selectHomeTrans(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to, "CashBook");
                    $transOpening=modelStatements::selectHomeTransOpening(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to,  "CashBook");
                    $openingBalance=$transOpening[0]->total;
                }
                else
                {
                    $myRateValidation=modelStatements::selectRate(Session::get('PropertyCode'),$curr,$AccCode,$AccSubCode, $from, $to);

                    if(count($myRateValidation)==0)
                    {
                        return redirect()->route('cashbookreport')->withErrors(['error' => 'Cannot Run This Report With The Selected Currency' ]);
                    }
                    else
                    {
                    $trans=modelStatements::selectTrans(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to,"CashBook");
                    $transOpening=modelStatements::selectTransOpeningBalance(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to,  "CashBook");
                    $openingBalance=$transOpening[0]->total;
                }

                }

            }
            else
            {
                return redirect()->route('cashbookreport')->withErrors(['error' => 'Home Currency Not Found' ]);
        
            }


           
            return view('/CashBookReport', compact('Accounts','trans','name','code','currencys','from','to','currnames','openingBalance'));

        }

        
        public function indexTax()
        {
          
    
                try
                {

                    $taxs=modelStatements::selectTax(Session::get('PropertyCode'));
    
                     $currencys=modelStatements::selectcurrency(Session::get('PropertyCode'));
               
                     $currnames="";
                $code=  "0000";
                $pfrom="";
                $pto="";
                $from="";
                $to="";
               
                $name="Tax";
    
                    $trans=modelStatements::selectTrans1(Session::get('PropertyCode'));
    
                    return view('/TaxReport', compact('trans','code','pfrom','pto','from','to','name','taxs','currnames','currencys'));
                   
    
    
            } catch (\Exception $e) {
                
                return redirect()->route('otheraccounts')->withErrors(['error' => 'An error occurred!!' . $e->getMessage()]);
            }
    
            }



            
        public function fetchTax(Request $request)
        {

            $request->validate([
                'tax' => 'required|string',
                 'from' => 'required|string',
                  'to' => 'required|string',
                  'pfrom' => 'required|string',
                  'pto' => 'required|string',
                  'curr' => 'required|string'
                
            ]);

         

            $Rate=1;
            $tax = $request->input('tax');
            $from = $request->input('from');
            $to = $request->input('to');
            $pfrom = $request->input('pfrom');
            $pto = $request->input('pto');
            $curr = $request->input('curr');
            $AccSubCode="0";
            $AccCode ="0";
            $name=  "";
            $code=  "";

           
            $taxs=modelStatements::selectTax(Session::get('PropertyCode')); 
            $currname=modelStatements::selectcurrencyName(Session::get('PropertyCode'),$curr);
            $currnames=$currname[0]->Name;

            if($tax=="All")
            {
                $name=  "Tax Report";
                $code=  "Tax Report";
            }
            else
            {
            $Accounts=modelStatements::selectTaxByID(Session::get('PropertyCode'),$tax);
            $name=  $Accounts[0]->Name;
            $code=  $Accounts[0]->Name;
            }

            $currencys=modelStatements::selectcurrency(Session::get('PropertyCode'));
            $trans=modelStatements::selectTransTax(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to,"Tax",$pfrom,$to,$tax);
  
            $selectHomeCurrency=modelStatements::selectHomeCurrency(Session::get('PropertyCode'));

            if(count($selectHomeCurrency)>0)
            {
                $homeCurrency=$selectHomeCurrency[0]->Currency; 
                if($curr==$homeCurrency)
                {

                    $trans=modelStatements::selectHomeTransTax(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to,"Tax",$pfrom,$to,$tax);


                }
                else
                {
                    $myRateValidation=modelStatements::selectRate(Session::get('PropertyCode'),$curr,$AccCode,$AccSubCode, $from, $to);

                    if(count($myRateValidation)==0)
                    {
                        return redirect()->route('TaxReport')->withErrors(['error' => 'Cannot Run This Report With The Selected Currency' ]);
                    }
                    else
                    {
                    $trans=modelStatements::selectTransTax(Session::get('PropertyCode'),$AccCode,$AccSubCode,$curr, $from , $to,"Tax",$pfrom,$to,$tax);
                    }

                }

            }
            else
            {
                return redirect()->route('TaxReport')->withErrors(['error' => 'Home Currency Not Found' ]);
        
            }


           
            
            return view('/TaxReport', compact('trans','code','pfrom','pto','from','to','name','taxs','currnames','currencys'));
                   
    

        }

}
