
@extends('layouts.nav')
@section('title')
General Ledger
@endsection
@section('content')               

@php
$PermissionsAddMainAccount = App\Models\PermissionsUserModel::getPermission('Add General Ledger', Auth::user()->id);
$PermissionsEditMainAccount = App\Models\PermissionsUserModel::getPermission('Edit General Ledger', Auth::user()->id);
$PermissionsDeleteMainAccount = App\Models\PermissionsUserModel::getPermission('Delete General Ledger', Auth::user()->id);
@endphp
<div class="d-sm-flex align-items-center justify-content-between mb-4">
                        <h1 class="h3 mb-0 text-gray-800">Main Accounts</h1>
                      </div>
                  
                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary"   id="formHeader">Create Main Accounts</h6>
                        </div>
                        @if (session('success'))
                            <div class="alert alert-success" id="successMessage"  style="margin: 20px;">
                                {{ session('success') }}
                            </div>
                        @endif
                      
                        @if ($errors->any())

                                    <div class="form-group"  id="successMessage"  style="margin: 20px;">
                                        <div class="card bg-warning text-white shadow">
                                            <div class="card-body">
                                        
                                                @foreach ($errors->all() as $error)
                                                <div style="color: red; ">{{ $error }}</div>
                                                @endforeach
                                        
                                            </div>
                                        </div>
                                    </div>
                                    @endif
                            @if(!empty($PermissionsAddMainAccount))
                            <form class="card-body" action="{{route('addMainAccount')}}" method="post"  id="accountTypeForm">
                            @csrf
                            <input type="hidden" id="accountId" name="id" value="">
                                
                                <div class="form-group row">
                                    <div class="col-sm-4 mb-3 mb-sm-0">
                                    <select class="form-control form-control-user" id="type" name="type"  value="{{ old('type') }}"  required>
                                        <option value="" disabled selected>Select Account Type</option>

                                        @foreach ($accountsTypes as $accountsType)
                                        
                                        <option value="{{ $accountsType->ID }}">{{ $accountsType->Name }}</option>
                                          
                                        @endforeach
                                    </select>
                                    </div>
                                    <div class="col-sm-4 mb-3 mb-sm-0">
                                        <input type="text" class="form-control form-control-user" id="AccName" placeholder="Account Name" name="AccName"  value="{{ old('AccName') }}" required>
                                    </div>
                                    <div class="col-sm-4">
                                        <input type="text" class="form-control form-control-user" id="AccCode" placeholder="Account Code" name="AccCode"  value="{{$generatedCodeValue }}" required   >
                                    </div>
                                </div>


                               <div style="display: flex;">
                               <input type="submit" style="width: 100px;height: 40px; margin-right: 10px; margin-top: 6px" value="Create" class="btn btn-primary btn-user btn-block" id="submitButton"/>

                                <input style="width: 100px;" onclick="refreshAccountType('', '', '', '')"  type="reset" value="Refresh" class="btn btn-secondary btn-user btn-block"  onclick="hideMessages()"/>
                                    
                               </div>
                                
                                <hr>
                             </form>
                             @endif
                   
                        
                        
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                                    <thead>
                                        <tr>
                                            <th>Account Type</th>
                                            <th>Account Code</th>
                                            <th>Account Name</th>
                                            <th>Sub Account</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    <tfoot>
                                        <tr>
                                        
                                        
                                        <th>Account Type</th>
                                            <th>Account Code</th>
                                            <th>Account Name</th>
                                            <th>Sub Account</th>
                                            <th>Action</th>

                                        </tr>
                                    </tfoot>
                                    <tbody>
                                       
                                    @foreach ($mainAccounts as $mainAccount)
                                            <tr>
                                        
                                                <td>{{ $mainAccount->Name }}</td> 
                                                <td>{{ $mainAccount->AccCode }}</td>
                                                <td>{{ $mainAccount->AccName }}</td>
                                                <td><a href="{{ route('subAccounts', ['id' => $mainAccount->AccCode,'name' => $mainAccount->AccName]) }}" class="btn btn-primary btn-icon-split btn-sm">
                                                        <span class="icon text-white-50">
                                                        <i class="fas fa-arrow-right"></i>
                                                        </span>
                                                        <span class="text">Sub Account</span>
                                                    </a>
                                                </td>
                                                 

                                                <td style="justify-content: center; align-items: center;">
                                                    @if(!empty($PermissionsEditMainAccount))          
                                                    <a href="" onclick="editAccountType(event,'{{ $mainAccount->ID }}', '{{ $mainAccount->acctype }}', '{{ $mainAccount->AccCode }}', '{{ $mainAccount->AccName }}')"  class="btn btn-primary btn-circle" >
                                                    <i class="fas fa-edit"></i>
                                                    </a>
                                                    @endif
                                                    @if(!empty($PermissionsDeleteMainAccount))
                                                    <a href="{{ route('deleteMainAccount', ['id' => $mainAccount->ID]) }}" class="btn btn-danger btn-circle"   onclick="return confirmDelete('{{ $mainAccount->AccName }}');" >
                                                        <i class="fas fa-trash"></i>
                                                    </a>
                                                    @endif
                                                </td>
                                                
                                            </tr>
                                        @endforeach
                                           
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        
                    </div>

                    <script>
                             function editAccountType(event, id, type,AccCode, AccName) 
                             {
                                event.preventDefault();
                                document.getElementById('accountId').value = id;
                                document.getElementById('type').value = type;
                                document.getElementById('AccCode').value = AccCode;
                                document.getElementById('AccName').value = AccName;
                                document.getElementById('formHeader').innerText = 'Edit Main Account';
                                document.getElementById('submitButton').value = 'Update';
                                document.getElementById('accountTypeForm').action = '{{route("editMainAccount")}}';
                            }
                
                            function refreshAccountType(id, type,AccCode, AccName) 
                            {
                                document.getElementById('accountId').value = id;
                                document.getElementById('type').value = type;
                                document.getElementById('AccCode').value = AccCode;
                                document.getElementById('AccName').value = AccName;
                                document.getElementById('formHeader').innerText = 'Create Main Accounts';
                                document.getElementById('submitButton').value = 'Create';
                                document.getElementById('accountTypeForm').action = '{{route("addMainAccount")}}';
                                hideMessages();
                            
                            }

                            function confirmDelete(Name) {
                                return confirm("Are you sure you want to delete the Account Type: " + Name + "?");
                            }


                
                </script>

                    @endsection